-------------------------------------------------------------------------------
-- Filename:       le_seq_blink.vhd
-- History:
--   2006-7-14     First Version
-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity le_seq_blink is
  port (
    SYS_CLK   : in  std_logic;
    SYS_RST   : in  std_logic;
    le_timing : in  std_logic;
    le        : out std_logic_vector(0 to 3)
  );
end le_seq_blink;

architecture IMP of le_seq_blink is

  signal le_w       : std_logic_vector(0 to 3);
  signal le_tim     : std_logic;
  signal le_tim_reg : std_logic;

begin

  process(SYS_CLK)
  begin
    if SYS_CLK'event and SYS_CLK = '1' then
      if SYS_RST = '1' then
        le_tim_reg <= '0';
      else
        le_tim_reg <= le_timing;
      end if;
    end if;
  end process;

  le_tim <= le_timing and not le_tim_reg;

  process(SYS_CLK)
  begin
    if SYS_CLK'event and SYS_CLK = '1' then
      if SYS_RST = '1' then
        le_w <= "0001";
      else
        if le_tim = '1' then
          le_w <= le_w(1 to 3) & le_w(0);
        end if;
      end if;
    end if;
  end process;

  le <= le_w;

end imp;
